uint8_t datchik = D0; // датчик подсоединен к цифровому выводу 2
int impuls; // переменная для хнанения значения сигнала с оптического датчика

uint8_t pwm_1_1 = D1; //канал подсоединен к цифровому выводу D1, На этот порт подключается 1 управляющий контакт LN298N
uint8_t pwm_2_1 = D2; //канал подсоединен к цифровому выводу D2, На этот порт подключается 2 управляющий контакт LN298N
uint8_t pwm_2_2 = D3; //канал подсоединен к цифровому выводу D3, На этот порт подключается 3 управляющий контакт LN298N
uint8_t pwm_1_2 = D4; //канал подсоединен к цифровому выводу D4, На этот порт подключается 4 управляющий контакт LN298N
uint8_t pwm_1_3 = D5; //канал подсоединен к цифровому выводу D5, На этот порт подключается 1 управляющий контакт LN298N
uint8_t pwm_2_3 = D6; //канал подсоединен к цифровому выводу D6, На этот порт подключается 2 управляющий контакт LN298N
uint8_t pwm_2_4 = D7; //канал подсоединен к цифровому выводу D7, На этот порт подключается 3 управляющий контакт LN298N
uint8_t pwm_1_4 = D8; //канал подсоединен к цифровому выводу D8, На этот порт подключается 4 управляющий контакт LN298N

void setup(){
  analogWriteFreq(31400); // частота шим сигнала 31,4 kHz
  pinMode(datchik, INPUT);  // D0 пин как вход
  pinMode(pwm_1_1, OUTPUT); // D1 пин как выход
  pinMode(pwm_2_1, OUTPUT); // D2 пин как выход
  pinMode(pwm_2_2, OUTPUT); // D3 пин как выход
  pinMode(pwm_1_2, OUTPUT); // D4 пин как выход
  pinMode(pwm_1_3, OUTPUT); // D5 пин как выход
  pinMode(pwm_2_3, OUTPUT); // D6 пин как выход
  pinMode(pwm_2_4, OUTPUT); // D7 пин как выход
  pinMode(pwm_1_4, OUTPUT); // D8 пин как выход
}
void loop(){
  uint16_t potenc_r =  analogRead(A0); //Потенциометр подключаем к выходу А0 для управления ШИМ сигналом
  if(potenc_r > 980) potenc_r = 1023;
  impuls = digitalRead(datchik); // считываем значение с входа

  switch(impuls){
  
  case HIGH:
  analogWrite(pwm_1_1, potenc_r);
  digitalWrite(pwm_2_1, LOW);
  digitalWrite(pwm_2_2, LOW);
  analogWrite(pwm_1_2, potenc_r);
  analogWrite(pwm_1_3, potenc_r);
  digitalWrite(pwm_2_3, LOW);
  digitalWrite(pwm_2_4, LOW);
  analogWrite(pwm_1_4, potenc_r);
  break;
  
  case LOW:
  digitalWrite(pwm_1_1, LOW);
  analogWrite(pwm_2_1, potenc_r);
  analogWrite(pwm_2_2, potenc_r);
  digitalWrite(pwm_1_2, LOW);
  digitalWrite(pwm_1_3, LOW);
  analogWrite(pwm_2_3, potenc_r);
  analogWrite(pwm_2_4, potenc_r);
  digitalWrite(pwm_1_4, LOW);
  break;
  }

}
